package com.taais.biz.listener;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.taais.biz.domain.bo.ToInfraredBo;
import com.taais.biz.domain.vo.ToInfraredImportVo;
import com.taais.biz.domain.vo.ToInfraredVo;
import com.taais.biz.service.IToInfraredService;
import com.taais.common.core.exception.ServiceException;
import com.taais.common.core.utils.SpringUtils;
import com.taais.common.core.utils.ValidatorUtils;
import com.taais.common.excel.core.ExcelListener;
import com.taais.common.excel.core.ExcelResult;
import lombok.extern.slf4j.Slf4j;

import java.util.List;

/**
 * 可见光转红外自定义导入
 *
 * @author 0
 */
@Slf4j
public class ToInfraredImportListener extends AnalysisEventListener<ToInfraredImportVo> implements ExcelListener<ToInfraredImportVo> {
    private final IToInfraredService toInfraredService;

    private final Boolean isUpdateSupport;
    private int successNum = 0;
    private int failureNum = 0;
    private final StringBuilder successMsg = new StringBuilder();
    private final StringBuilder failureMsg = new StringBuilder();

    public ToInfraredImportListener(Boolean isUpdateSupport) {
        this.toInfraredService = SpringUtils.getBean(IToInfraredService.class);
        this.isUpdateSupport = isUpdateSupport;
    }

    @Override
    public void invoke(ToInfraredImportVo toInfraredVo, AnalysisContext context) {
        try {

            ToInfraredBo toInfraredBo = BeanUtil.toBean(toInfraredVo, ToInfraredBo.class);

            //TODO:根据某个字段，查询数据库表中是否存在记录，不存在就新增，存在就更新
            ToInfraredVo toInfraredVo1 = null;

            //toInfraredVo1 = toInfraredService.selectBySomefield(toInfraredVo.getSomefield());
            if (ObjectUtil.isNull(toInfraredVo1)) {
                //不存在就新增
                toInfraredBo.setVersion(0);
                ValidatorUtils.validate(toInfraredBo);
                boolean inserted = toInfraredService.insert(toInfraredBo);

                if (inserted) {
                    successNum++;
                    successMsg.append("<br/>").append(successNum).append("、可见光转红外 记录导入成功");
                    return;
                } else {
                    failureNum++;
                    failureMsg.append("<br/>").append(failureNum).append("、可见光转红外 记录导入失败");
                    return;
                }
            } else if (isUpdateSupport) {
                //存在就更新
                toInfraredBo.setId(toInfraredVo1.getId());//主键
                toInfraredBo.setVersion(toInfraredVo1.getVersion());
                boolean updated = toInfraredService.update(toInfraredBo);
                if (updated) {
                    successNum++;
                    successMsg.append("<br/>").append(successNum).append("、可见光转红外 记录更新成功");
                    return;
                } else {
                    failureNum++;
                    failureMsg.append("<br/>").append(failureNum).append("、可见光转红外 记录更新失败");
                    return;
                }
            }
        } catch (Exception e) {
            failureNum++;
            String msg = "<br/>" + failureNum + "、可见光转红外 记录导入失败：";
            failureMsg.append(msg).append(e.getMessage());
            log.error(msg, e);
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {

    }

    @Override
    public ExcelResult<ToInfraredImportVo> getExcelResult() {
        return new ExcelResult<>() {

            @Override
            public String getAnalysis() {
                if (failureNum > 0) {
                    failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据没有成功导入，错误如下：");
                    throw new ServiceException(failureMsg.toString());
                } else {
                    successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
                }
                return successMsg.toString();
            }

            @Override
            public List<ToInfraredImportVo> getList() {
                return null;
            }

            @Override
            public List<String> getErrorList() {
                return null;
            }
        };
    }
}
